<?php

/*********************************************************************************************************
* SPAMFINDER V0.1																														*
* ===============																														*
*																																			*
* Synopsis																																*
* --------																																*
* Spamfinder ist ein kleines Skript um Spam-Attacken in Gästebüchern, Foren und Kommentarfunktionen		*
* zu reduzieren. Die zu filternden Wörter, IP-Adressen etc. werden automatisch von 								*
* http://www.antikoerperchen.de/spamfilter gezogen, sie können diese Daten aber durch eigene 				*
* Filterlisten ergänzen.																											*
* Die Filterlisten lauten:																											*
* forbidden_ips.txt    - Filtert bestimmte IP-Adressen (bisher keine IP-Bereiche möglich)						*
* forbidden_words.txt  - Filtert den Kommentar auf bestimmte Wörter (z.B. Phentermine, Viagra).				*
*							 	 Der Spamfilter schlägt erst ab einer bestimmten Wortdichte zu.						*
* forbidden_text.txt   - Filtert typische Spamtexte.																		*
* forbidden_links.txt  - Filtert bestimmte Links in Homepage und E-Mail-Adresse. 								*
*							    Bisher sind aber keine Wildcards möglich. 												   *
* forbidden_emails.txt - Filtert bestimmte E-Mail-Adressen.				   											*
*																																			*
*																																			*
* Installation																															*
* ------------																															*
* Kopieren sie das Skript samt restliche Dateien in das Unterverzeichnis "spamfinder".						   *
* Zur Integration in den Quellcode müssen 2 Änderungen durchgeführt werden:										*
*  1. Hinzufügen von: 																												*
*		require_once("/spamfinder/spamfinder.inc.php");																		*
*	2. Prüfen der Kommentareingaben vor der Eintragung. Beispiel:														*
*     $akt_verzeichnis=getcwd();																									*
*		chdir("./spamfinder");																										*
*		if ($spamresult=spamfinder($_POST["betreff"], 																		*
*                                $_POST["name"], 																			*
*                                $_POST["email"], 																			*
*                                $_POST["homepage"], 																		*
*                                $_POST["text"], 																			*
*                                $_POST["hiddenfield"], 																	*
*                                $_POST["timestamp"]) {																	*
*			Hier wird der Kommentar eingetragen																					*
*			} else echo $spamresult;																								*
*		chdir($akt_verzeichnis);																									*
*																																			*
* Passen sie die Variablen in dem Beispiel bitte an ihre eigenen Variablennamen an. Die letzten beiden	*
* Variablen können leergelassen werden (also einfach "" übergeben), ich empfehle allerdings, dass sie		*
* diese 2 zusätzlichen Input-Felder in ihrem Formular hinzufügen:														*
* Hiddenfield - Dies ist ein Feld, welches mit CSS versteckt wird. Spambots füllen alle Felder				*
*					 in Formularen aus, für Menschen ist dieses Feld allerdings unsichtbar.							*
*					 Sollte Hiddenfield also ausgefüllt sein, so kann man davon ausgehen, dass es sich um		*
*					 einen Spambot handelt.																							*
*					 Quellcode: <span style="visibility: hidden;"><input type="text" /></span>						*
* Timestamp   - Dieses Feld ist hilfreich, um zu überprüfen, wie lange ein Mensch/Bot gebraucht hat,		*
* 					 um den Beitrag zu schreiben. Sollte dieser Wert sehr niedrig sein (< 5 Sekunden), 			*
*					 wird angenommen, dass es sich um einen Bot handelt.													*
*					 Quellcode: <input type="hidden"  value="<?php echo time(); ?>" />								*
*																																			*
*																																			*
* To do																																	*
* -----																																	*
* -Geblockte Spam-Kommentare über Interface anzeigen																      *
* -Interface zum editieren der Filter																							*
* -Zeitpunkt der Nachrichten einer bestimmten IP speichern und vergleichen 										*
*  (z.B. mehr als 3 Kommentare pro 5 Minuten könnten als Spam gelten)										   	*
* -Sternchen-Wildcard für verbotene Domains und E-Mail-Adressen	   												*
* -Synchronisation mit zentraler Datenbank auf www.antikoerperchen.de(?)											*
*																																			*
*																																		   *
* Autor																																	*
* -----																																	*
* Dirk Niemeier																														*
* ICQ# 158109607																														*
* the_new_strangeness@yahoo.de																									*
* http://blog.antikoerperchen.de																									*
*																																			*
*********************************************************************************************************/

function spamfinder($betreff, $name, $email, $homepage, $text, $hiddenfield, $timestamp) {

$orig_betreff=$betreff;
$orig_name=$name;
$orig_email=$email;
$orig_homepage=$homepage;
$orig_text=$text;
$orig_hiddenfield=$hiddenfield;
$orig_timestamp=$timestamp;

$akt_verzeichnis=getcwd();
@chdir("./spamfinder");
require("settings.inc.php");

/*
Prüfe, ob verstecktes Feld ausgefüllt wurde
*/
if ($hiddenfield!="") { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['hiddenfield']; }

/*
Prüfe Länge von E-Mail-Adresse, Name und Betreff
*/
if (strlen($name)>$_SPAMFINDER['max_laenge_name']) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['name_too_long']; }
if (strlen($email)>$_SPAMFINDER['max_laenge_email']) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['email_too_long']; }
if (strlen($betreff)>$_SPAMFINDER['max_laenge_homepage']) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return "Homepage zu lang."; }
if (strlen($betreff)>$_SPAMFINDER['max_laenge_betreff']) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['topic_too_long']; }

/*
Prüfe, ob Bot sich freigiebig als Bot/Spider/Spam/Crawler identifiziert
*/
if ((strpos(strtolower(" ".getenv("HTTP_USER_AGENT")), "spam")) || 
    (strpos(strtolower(" ".getenv("HTTP_USER_AGENT")), "bot")) || 
    (strpos(strtolower(" ".getenv("HTTP_USER_AGENT")), "crawler")) || 
    (strpos(strtolower(" ".getenv("HTTP_USER_AGENT")), "spider"))) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['spambot_useragent']; }

/*
Prüfe die Größee des Intervalls, in der die Nachricht geschrieben wurde
*/
$aktueller_timestamp=time();
if ($timestamp!="")
	if (($aktueller_timestamp-$timestamp)<$_SPAMFINDER['intervall']) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['too_short_timestamp_difference']; }



/*
Prüfe ob Zeilenumbrüche in Homepage, E-Mail, Betreff oder Name benutzt wurden
*/
$line_breaks=array("\n",
						 "\r");
foreach($line_breaks as $linebreak) { 
	if ((strpos($name, $linebreak) || (strpos($email, $linebreak)) || (strpos($betreff, $linebreak))|| (strpos($homepage, $linebreak))))
			{ spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_linebreaks']; }
		}


/*
Speichere die Zeit, zu der die Nachricht abgeschickt wurde und blocke, falls mehr als 3 Nachrichten innerhalb von 10 Minuten geschrieben werden.
Bedenke: Shoutboxes
*/


/*
Prüfe, ob Links in der E-Mail-Adresse, dem Betreff oder dem Namen eingegeben wurden
*/
$url_tags=array("[url=",
					 "[link=",
					 "http://"); 

foreach($url_tags as $url_tag) {
	if ((strpos(" ".$name, $url_tag) || (strpos(" ".$email, $url_tag)) || (strpos(" ".$betreff, $url_tag)))) {
		{ spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_url_tags']; }
		}
	}

/*
Prüfe die Anzahl der Links in der Nachricht in Relation zur Nachrichtenlänge
*/
$quotient=strlen($text)*$_SPAMFINDER['max_quotient_links'];
	
$url_tags_length=array();
foreach($url_tags as $url_tag) {
	$max_link=floor($quotient/strlen($url_tag));
	if ($max_link<$_SPAMFINDER['min_allowed_links']) $max_link=$_SPAMFINDER['min_allowed_links'];
	array_push($url_tags_length, $max_link);
	}

$i=0;
foreach($url_tags as $url_tag) {
	if (substr_count($text, $url_tag)>$url_tags_length[$i]) {
		{ spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['too_many_links']; }
		}		
	$i++;
	}
		
/*
Prüfe auf verbotene Links
*/
if ($homepage!="" || $email!="") {
	$forbidden_links=spamfinder_get_central_filterlist("forbidden_links.txt");
	$forbidden_links_local=@file($_SPAMFINDER['forbidden_files']['links']);
	$forbidden_links=array_merge($forbidden_links, $forbidden_links_local);
	$forbidden_links=array_unique($forbidden_links);
	
/*
	$forbidden_links_foreign=spamfinder_get_foreign_filterlist("http://spam.blogg.de/blacklist.txt");
	$forbidden_links=array_merge($forbidden_links, $forbidden_links_foreign);
	$forbidden_links=array_unique($forbidden_links);
*/
	
	
	foreach($forbidden_links as $link) {
		$link=trim($link);
		if ($link!="") {
 	   if (strpos(" ".$homepage, $link) || strpos(" ".$email, $link)) {
 	   	{ spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_link']; }
 	   	}
 		}
	}
}

/*
Prüfe auf verbotene E-Mail-Adressen
*/
if ($email!="") {
	$forbidden_mails=spamfinder_get_central_filterlist("forbidden_emails.txt");
	$forbidden_mails_local=@file($_SPAMFINDER['forbidden_files']['emails']);
	$forbidden_mails=array_merge($forbidden_mails, $forbidden_mails_local);
	$forbidden_mails=array_unique($forbidden_mails);
	
	foreach($forbidden_mails as $mail) {
		$mail=trim($mail);
		if ($mail!="") {
 	   if (strpos(" ".$email, $mail)) {
 	   	{ spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_email']; }
 	   	}
 		}
	}
}

/*
Prüfe auf verbotene Textanfänge
*/
if ($text!="") {
	$forbidden_text=spamfinder_get_central_filterlist("forbidden_text.txt");
	$forbidden_text_local=@file($_SPAMFINDER['forbidden_files']['text']);
	$forbidden_text=array_merge($forbidden_text, $forbidden_text_local);
	$forbidden_text=array_unique($forbidden_text);
	
	$forbidden_text_length=array();
	foreach($forbidden_text as $spamtext) {
		$max_length=strlen($spamtext);
		array_push($forbidden_text_length, $max_length);
		}

	$i=0;
	foreach($forbidden_text as $spamtext) {
		$spamtext=trim($spamtext);
		if ($spamtext!="") {
			$textpart=substr($text, 0, $forbidden_text_length[$i]);
			if (strtolower($textpart)==strtolower($spamtext))
				{ spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_text']; }
			}
		$i++;
		}			
	}


/*
Prüfe auf verbotene IPs und IP-Bereiche
*/
$benutzer_ip=getenv("REMOTE_ADDR");
$forbidden_ips=spamfinder_get_central_filterlist("forbidden_ips.txt");
$forbidden_ips_local=@file($_SPAMFINDER['forbidden_files']['ips']);
$forbidden_ips=array_merge($forbidden_ips, $forbidden_ips_local);
$forbidden_ips=array_unique($forbidden_ips);

foreach($forbidden_ips as $forbidden_ip) {
	if (!$bindestrichpos=strpos($forbidden_ip, "-")) {
		if (!$sternchenpos=strpos($forbidden_ip, "*")) {
			if ($benutzer_ip==trim($forbidden_ip)) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_ip']; }
			} else {
				echo "Sternchen-Wildcard bislang nicht implementiert.";
				}
		} else {
			$forbidden_ip1=substr($forbidden_ip, 0, $bindestrichpos);
			$forbidden_ip2=substr($forbidden_ip, ++$bindestrichpos, strlen($forbidden_ip));
			$ips1=explode(".", $forbidden_ip1);
			$ips2=explode(".", $forbidden_ip1);
			$benutzer_ip_array=explode(".", $benutzer_ip);
			$i=0;
			foreach($ips1 as $ip) {
//					echo "<br />IP-Chunk: ".$ip;
//					echo "<br />Benutzer-IP-Chunk: ".$benutzer_ip_array[$i];
					if ($ip>=$benutzer_ip_array[$i]) {$stop=true; break;} else $i++; 
					}
			if (!$stop) {
				$i=0;
				foreach($ips2 as $ip) {
						if ($ip<=$benutzer_ip_array[$i]) {$stop=true; break;} else $i++; 
						}
				}
			if ($stop) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_ip_range']; }
			
//			if ($benutzer_ip>=$forbidden_ip1 && $benutzer_ip<=$forbidden_ip2) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_ip_range']; }
			}	
	}			


/*
Prüfe auf verbotene Wörter
*/
if ($text!="")
	{
	$text2=strtolower($text);

	$forbidden_words=spamfinder_get_central_filterlist("forbidden_words.txt");
	$forbidden_words_local=@file($_SPAMFINDER['forbidden_files']['words']);
	$forbidden_words=array_merge($forbidden_words, $forbidden_words_local);
	$forbidden_words=array_unique($forbidden_words);
	
	array_push($forbidden_words, "");
	$arraylaenge=count($forbidden_words);
	$find=0;
	
	
	//Erlaube $anzahl_bad_words pro $anzahl_zeichen
 	$anzahl_zeichen=$_SPAMFINDER['max_allowed_bad_words_per_chars']['chars'];
	$anzahl_bad_words=$_SPAMFINDER['max_allowed_bad_words_per_words']['max_bad_words_in_relation_of_chars'];
	
	$max_bad_words_proz=$anzahl_bad_words/$anzahl_zeichen;
	$quotient=floor(strlen($text2)*$max_bad_words_proz);
	if ($quotient==0) $quotient=1;

	for ($m=0; $m<=$arraylaenge; $m++) { 
			if (($forbidden_words[$m]!="") && (strpos(" ".$text2, strtolower(trim($forbidden_words[$m]))))) {
				$find+=substr_count(" ".$text2, strtolower(trim($forbidden_words[$m])));
/*
				echo "<br />Text: ".$text2;
				echo "<br />Forbidden-Word: ".$forbidden_words[$m];
				echo "<br />Find: ".$find;
				echo "<br />Quotient: ".$quotient;
				echo "<hr />";
*/
				if ($find>=$quotient) { spamfinder_save_message($orig_betreff, $orig_name, $orig_email, $orig_homepage, $orig_text, $orig_hiddenfield, $orig_timestamp); chdir($akt_verzeichnis); return $_SPAMFINDER['messages']['forbidden_words']; }
				}
			}
	}
chdir($akt_verzeichnis);
}

function spamfinder_get_central_filterlist($datei) {
	//if (fsockopen("www.antikoerperchen.de", 80)) 
	return @file("http://www.antikoerperchen.de/spamfinder/$datei");
	}

function spamfinder_get_foreign_filterlist($datei) {
	//if (fsockopen($datei, 80)) 
	return @file($datei);
	}
	
function spamfinder_save_message($betreff, $name, $email, $homepage, $text, $hiddenfield, $timestamp) {
	require("settings.inc.php");
	$datum=date("d.m.Y");
	$zeit=date("H:i:s");
	if ($_SPAMFINDER['save_spam']=true) {
		$timestamp=$timestamp-time();
								    $message= "Gespeichert am $datum, um $zeit Uhr:\n";
								    $message.="URL: ".getenv("REQUEST_URI")."\n";
		if ($betreff!="")     $message.="Betreff: $betreff\n";
		if ($name!="")     	 $message.="Name: $name\n";
		if ($email!="")    	 $message.="E-Mail: $email\n";
		if ($homepage!="")	 $message.="Homepage: $homepage\n";
		if ($hiddenfield!="") $message.="Hiddenfield: $hiddenfield\n";
		if ($timestamp>=0)    $message.="Timestamp-Unterschied: $timestamp\n";
		if ($text!="")		 	 $message.="Text: $text";
		$spamverzeichnis=$_SPAMFINDER['save_detected_spam_directory'];
		$permissions=substr(decoct(fileperms($spamverzeichnis)), 2, 3);
		if ($permissions=="777") {
			$id=spamfinder_neue_datei_id_finden($spamverzeichnis);
			$handle=fopen($spamverzeichnis."/".$id.".txt", "w");
 			fwrite($handle, $message);
 			fclose($handle);
			}
		}
	}
	
function spamfinder_neue_datei_id_finden($verzeichnis) {
	$id=1;
	while ($id!=0)
 	{
 	if (!file_exists("$verzeichnis/$id.txt"))
    	{
    	$neueid=$id;
    	$id=0;
    	} else
    		{
    		$id++;
    		}
 	}
	return $neueid;
	}

?>